
public class LinkedList {

    class ListNode {

        ListNode next;
        Object item;

        ListNode(Object item) {
            this.item = item;
            next = null;
        }
    }

    ListNode start;

    public LinkedList() {
        start = null;
    }

    public LinkedList push(Object obj) {
        ListNode node = new ListNode(obj);
        if (start == null) {
            start = node;
        } else {
            node.next = start;
            start = node;
        }
        return this;
    }

    public void print() {
        ListNode cur = start;
        while (cur != null) {
            System.out.print(cur.item + (cur.next == null ? "\n" : " "));
            cur = cur.next;
        }
    }

}
