
import java.util.Iterator;
import java.util.NoSuchElementException;

public class LinkedListIterable extends LinkedList implements Iterable {

    private class LLIterator implements Iterator {

        private ListNode cur;

        private LLIterator(ListNode cur) {
            this.cur = cur;
        }

        @Override
        public boolean hasNext() {
            return cur != null;

        }

        @Override
        public Object next() {
            if (cur == null) {
                throw new NoSuchElementException();
            }
            Object ret = cur.item;
            cur = cur.next; //move forward
            return ret;
        }
    }

    @Override
    public Iterator iterator() {
        return new LLIterator(start);
    }
}
